package com.basic.eyflutter_core.greens;

import android.content.Context;
import android.os.Build;

import com.cloud.eyutils.beans.BasicConfigItem;
import com.cloud.eyutils.events.OnEntryCall;
import com.cloud.eyutils.launchs.LauncherState;

import java.io.File;

import static android.os.Environment.DIRECTORY_DOCUMENTS;

/**
 * Author lijinghuan
 * Email:ljh0576123@163.com
 * CreateTime:2019-09-11
 * Description:
 * Modifier:
 * ModifyContent:
 */
public class BasicConfig implements OnEntryCall {

    private String packageName;

    public BasicConfig(String packageName) {
        this.packageName = packageName;
    }

    @Override
    public Object onEntryResult() {
        BasicConfigItem configItem = new BasicConfigItem();
        configItem.setDebug(false);
        configItem.setProjectPackgeName(packageName);
        Context applicationContext = LauncherState.getApplicationContext();
        File sdcardDir = new File("/storage/sdcard0");
        if (sdcardDir.exists()) {
            String rootDir = String.format("/storage/sdcard0/Android/data/%s/files/Documents", packageName);
            File dir = new File(rootDir);
            if (!dir.exists()) {
                dir.mkdirs();
            }
            configItem.setCacheRootDir(dir);
        } else {
            if (Build.VERSION.SDK_INT < Build.VERSION_CODES.Q) {
                configItem.setCacheRootDir(applicationContext.getExternalFilesDir(""));
            } else {
                configItem.setCacheRootDir(applicationContext.getExternalFilesDir(DIRECTORY_DOCUMENTS));
            }
            File cacheRootDir = configItem.getCacheRootDir();
            if (!cacheRootDir.exists()) {
                cacheRootDir.mkdirs();
            }
        }
        return configItem;
    }
}
