import 'package:eyflutter_core/eyflutter_core.dart';
import 'package:flutter/material.dart';

class EBusPage extends StatefulWidget {
  const EBusPage({Key? key}) : super(key: key);

  @override
  _EBusPageState createState() => _EBusPageState();
}

class _EBusPageState extends State<EBusPage> {
  @override
  Widget build(BuildContext context) {
    return Container(
      color: Colors.white,
      child: ListView.builder(
        itemBuilder: (BuildContext context, int index) {
          if (index == 0) {
            return ConstButton(
              text: "发送Bus事件",
              onLongPress: () {
                CloudEBus.instance.dispatch("bus_action", params: "message");
              },
            );
          }
          if (index == 1) {
            return const EBusTestPage();
          }
          return Center(child: Text("$index"));
        },
        itemCount: 2,
        itemExtent: 50,
      ),
    );
  }
}

class EBusTestPage extends StatefulWidget {
  const EBusTestPage({Key? key}) : super(key: key);

  @override
  _EBusTestPageState createState() => _EBusTestPageState();
}

class _EBusTestPageState extends State<EBusTestPage> {
  @override
  void initState() {
    super.initState();
    CloudEBus.instance.addEvent(this, action: "bus_action", method: busMethod);
  }

  @override
  Widget build(BuildContext context) {
    return Container();
  }

  void busMethod() {
    Logger.instance.info("receive bus message");
  }

  @override
  void dispose() {
    super.dispose();
    CloudEBus.instance.disposeEvent(this, action: "bus_action");
  }
}
